--Legal Notice: (C)2009 Altera Corporation. All rights reserved.  Your
--use of Altera Corporation's design tools, logic functions and other
--software and tools, and its AMPP partner logic functions, and any
--output files any of the foregoing (including device programming or
--simulation files), and any associated documentation or information are
--expressly subject to the terms and conditions of the Altera Program
--License Subscription Agreement or other applicable license agreement,
--including, without limitation, that your use is for the sole purpose
--of programming logic devices manufactured by Altera and sold by Altera
--or its authorized distributors.  Please refer to the applicable
--agreement for further details.


-- turn off superfluous VHDL processor warnings 
-- altera message_level Level1 
-- altera message_off 10034 10035 10036 10037 10230 10240 10030 

library altera;
use altera.altera_europa_support_lib.all;

library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;

-- c_subroutine_block
--../dma_c2h_tutorial.c (11): int do_dma( int * restrict dest_ptr, int * restrict source_ptr, int length )
entity accelerator_DMA_tutor_do_dma_do_dma0_state_machine_subroutine_0 is 
        port (
              -- inputs:
                 signal clk : IN STD_LOGIC;
                 signal do_dma_begin0 : IN STD_LOGIC;
                 signal do_dma_read0 : IN STD_LOGIC;
                 signal do_dma_select0 : IN STD_LOGIC;
                 signal inhibit_from_c_do_block0 : IN STD_LOGIC;
                 signal reset_n : IN STD_LOGIC;

              -- outputs:
                 signal advance_to_do_dma_state0 : OUT STD_LOGIC_VECTOR (5 DOWNTO 0);
                 signal do_dma_state0 : OUT STD_LOGIC_VECTOR (5 DOWNTO 0);
                 signal enable_do_dma_state0 : OUT STD_LOGIC_VECTOR (5 DOWNTO 0)
              );
end entity accelerator_DMA_tutor_do_dma_do_dma0_state_machine_subroutine_0;


architecture europa of accelerator_DMA_tutor_do_dma_do_dma0_state_machine_subroutine_0 is
                signal block_wide_enable0 :  STD_LOGIC;
                signal internal_advance_to_do_dma_state0 :  STD_LOGIC_VECTOR (5 DOWNTO 0);
                signal internal_do_dma_state0 :  STD_LOGIC_VECTOR (5 DOWNTO 0);
                signal internal_enable_do_dma_state0 :  STD_LOGIC_VECTOR (5 DOWNTO 0);

begin

  process (clk, reset_n)
  begin
    if reset_n = '0' then
      internal_do_dma_state0(0) <= std_logic'('0');
    elsif clk'event and clk = '1' then
      if std_logic'(internal_enable_do_dma_state0(0)) = '1' then 
        internal_do_dma_state0(0) <= internal_advance_to_do_dma_state0(0);
      end if;
    end if;

  end process;

  internal_enable_do_dma_state0(0) <= block_wide_enable0;
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      internal_do_dma_state0(1) <= std_logic'('0');
    elsif clk'event and clk = '1' then
      if std_logic'(internal_enable_do_dma_state0(1)) = '1' then 
        internal_do_dma_state0(1) <= internal_advance_to_do_dma_state0(1);
      end if;
    end if;

  end process;

  internal_enable_do_dma_state0(1) <= block_wide_enable0;
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      internal_do_dma_state0(2) <= std_logic'('0');
    elsif clk'event and clk = '1' then
      if std_logic'(internal_enable_do_dma_state0(2)) = '1' then 
        internal_do_dma_state0(2) <= internal_advance_to_do_dma_state0(2);
      end if;
    end if;

  end process;

  internal_enable_do_dma_state0(2) <= block_wide_enable0;
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      internal_do_dma_state0(3) <= std_logic'('0');
    elsif clk'event and clk = '1' then
      if std_logic'(internal_enable_do_dma_state0(3)) = '1' then 
        internal_do_dma_state0(3) <= internal_advance_to_do_dma_state0(3);
      end if;
    end if;

  end process;

  internal_enable_do_dma_state0(3) <= block_wide_enable0;
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      internal_do_dma_state0(4) <= std_logic'('0');
    elsif clk'event and clk = '1' then
      if std_logic'(internal_enable_do_dma_state0(4)) = '1' then 
        internal_do_dma_state0(4) <= internal_advance_to_do_dma_state0(4);
      end if;
    end if;

  end process;

  internal_enable_do_dma_state0(4) <= block_wide_enable0;
  internal_enable_do_dma_state0(5) <= block_wide_enable0;
  internal_advance_to_do_dma_state0(0) <= (do_dma_read0 AND do_dma_select0) AND do_dma_begin0;
  --advance_to_do_dma_state0[1] assign, which is an e_assign
  internal_advance_to_do_dma_state0(1) <= internal_do_dma_state0(0);
  --advance_to_do_dma_state0[2] assign, which is an e_assign
  internal_advance_to_do_dma_state0(2) <= internal_do_dma_state0(1);
  --advance_to_do_dma_state0[3] assign, which is an e_assign
  internal_advance_to_do_dma_state0(3) <= internal_do_dma_state0(2);
  --advance_to_do_dma_state0[4] assign, which is an e_assign
  internal_advance_to_do_dma_state0(4) <= internal_do_dma_state0(3);
  --advance_to_do_dma_state0[5] assign, which is an e_assign
  internal_advance_to_do_dma_state0(5) <= internal_do_dma_state0(4);
  --block_wide_enable0 inhibitor mux, which is an e_mux
  block_wide_enable0 <= Vector_To_Std_Logic(((std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(NOT(inhibit_from_c_do_block0)))) AND std_logic_vector'("00000000000000000000000000000001")));
  --vhdl renameroo for output signals
  advance_to_do_dma_state0 <= internal_advance_to_do_dma_state0;
  --vhdl renameroo for output signals
  do_dma_state0 <= internal_do_dma_state0;
  --vhdl renameroo for output signals
  enable_do_dma_state0 <= internal_enable_do_dma_state0;

end europa;



-- turn off superfluous VHDL processor warnings 
-- altera message_level Level1 
-- altera message_off 10034 10035 10036 10037 10230 10240 10030 

library altera;
use altera.altera_europa_support_lib.all;

library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;

-- c_subroutine_block
--../dma_c2h_tutorial.c (16):   {
entity accelerator_DMA_tutor_do_dma_do_dma0_state_machine_do_0 is 
        port (
              -- inputs:
                 signal accelerator_DMA_tutor_do_dma_dereferenced_dest_ptr1_write0_waitrequest_n0 : IN STD_LOGIC;
                 signal accelerator_DMA_tutor_do_dma_dereferenced_source_ptr1_read0_waitrequest_n0 : IN STD_LOGIC;
                 signal accelerator_DMA_tutor_do_dma_master_resource0_fifo_empty0 : IN STD_LOGIC;
                 signal advance_to_do_dma_state0 : IN STD_LOGIC_VECTOR (5 DOWNTO 0);
                 signal break1 : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                 signal break25 : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                 signal clk : IN STD_LOGIC;
                 signal enable_do_dma_state0 : IN STD_LOGIC_VECTOR (5 DOWNTO 0);
                 signal go_bit_control_output1 : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                 signal reset_n : IN STD_LOGIC;

              -- outputs:
                 signal advance_to_state_do_0 : OUT STD_LOGIC_VECTOR (15 DOWNTO 0);
                 signal enable_state_do_0 : OUT STD_LOGIC_VECTOR (15 DOWNTO 0);
                 signal inhibit_from_c_do_block0 : OUT STD_LOGIC;
                 signal state_do_0 : OUT STD_LOGIC_VECTOR (15 DOWNTO 0)
              );
end entity accelerator_DMA_tutor_do_dma_do_dma0_state_machine_do_0;


architecture europa of accelerator_DMA_tutor_do_dma_do_dma0_state_machine_do_0 is
                signal block_wide_enable1 :  STD_LOGIC;
                signal internal_advance_to_state_do_0 :  STD_LOGIC_VECTOR (15 DOWNTO 0);
                signal internal_enable_state_do_0 :  STD_LOGIC_VECTOR (15 DOWNTO 0);
                signal internal_state_do_0 :  STD_LOGIC_VECTOR (15 DOWNTO 0);

begin

  process (clk, reset_n)
  begin
    if reset_n = '0' then
      internal_state_do_0(0) <= std_logic'('0');
    elsif clk'event and clk = '1' then
      if std_logic'(internal_enable_state_do_0(0)) = '1' then 
        internal_state_do_0(0) <= internal_advance_to_state_do_0(0);
      end if;
    end if;

  end process;

  internal_enable_state_do_0(0) <= block_wide_enable1;
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      internal_state_do_0(1) <= std_logic'('0');
    elsif clk'event and clk = '1' then
      if std_logic'(internal_enable_state_do_0(1)) = '1' then 
        internal_state_do_0(1) <= internal_advance_to_state_do_0(1);
      end if;
    end if;

  end process;

  internal_enable_state_do_0(1) <= block_wide_enable1;
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      internal_state_do_0(2) <= std_logic'('0');
    elsif clk'event and clk = '1' then
      if std_logic'(internal_enable_state_do_0(2)) = '1' then 
        internal_state_do_0(2) <= internal_advance_to_state_do_0(2);
      end if;
    end if;

  end process;

  internal_enable_state_do_0(2) <= block_wide_enable1;
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      internal_state_do_0(3) <= std_logic'('0');
    elsif clk'event and clk = '1' then
      if std_logic'(internal_enable_state_do_0(3)) = '1' then 
        internal_state_do_0(3) <= internal_advance_to_state_do_0(3);
      end if;
    end if;

  end process;

  internal_enable_state_do_0(3) <= block_wide_enable1;
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      internal_state_do_0(4) <= std_logic'('0');
    elsif clk'event and clk = '1' then
      if std_logic'(internal_enable_state_do_0(4)) = '1' then 
        internal_state_do_0(4) <= internal_advance_to_state_do_0(4);
      end if;
    end if;

  end process;

  internal_enable_state_do_0(4) <= block_wide_enable1;
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      internal_state_do_0(5) <= std_logic'('0');
    elsif clk'event and clk = '1' then
      if std_logic'(internal_enable_state_do_0(5)) = '1' then 
        internal_state_do_0(5) <= internal_advance_to_state_do_0(5);
      end if;
    end if;

  end process;

  internal_enable_state_do_0(5) <= block_wide_enable1;
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      internal_state_do_0(6) <= std_logic'('0');
    elsif clk'event and clk = '1' then
      if std_logic'(internal_enable_state_do_0(6)) = '1' then 
        internal_state_do_0(6) <= internal_advance_to_state_do_0(6);
      end if;
    end if;

  end process;

  internal_enable_state_do_0(6) <= block_wide_enable1;
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      internal_state_do_0(7) <= std_logic'('0');
    elsif clk'event and clk = '1' then
      if std_logic'(internal_enable_state_do_0(7)) = '1' then 
        internal_state_do_0(7) <= internal_advance_to_state_do_0(7);
      end if;
    end if;

  end process;

  internal_enable_state_do_0(7) <= block_wide_enable1;
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      internal_state_do_0(8) <= std_logic'('0');
    elsif clk'event and clk = '1' then
      if std_logic'(internal_enable_state_do_0(8)) = '1' then 
        internal_state_do_0(8) <= internal_advance_to_state_do_0(8);
      end if;
    end if;

  end process;

  internal_enable_state_do_0(8) <= block_wide_enable1;
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      internal_state_do_0(9) <= std_logic'('0');
    elsif clk'event and clk = '1' then
      if std_logic'(internal_enable_state_do_0(9)) = '1' then 
        internal_state_do_0(9) <= internal_advance_to_state_do_0(9);
      end if;
    end if;

  end process;

  internal_enable_state_do_0(9) <= block_wide_enable1;
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      internal_state_do_0(10) <= std_logic'('0');
    elsif clk'event and clk = '1' then
      if std_logic'(internal_enable_state_do_0(10)) = '1' then 
        internal_state_do_0(10) <= internal_advance_to_state_do_0(10);
      end if;
    end if;

  end process;

  internal_enable_state_do_0(10) <= block_wide_enable1;
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      internal_state_do_0(11) <= std_logic'('0');
    elsif clk'event and clk = '1' then
      if std_logic'(internal_enable_state_do_0(11)) = '1' then 
        internal_state_do_0(11) <= internal_advance_to_state_do_0(11);
      end if;
    end if;

  end process;

  internal_enable_state_do_0(11) <= block_wide_enable1;
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      internal_state_do_0(12) <= std_logic'('0');
    elsif clk'event and clk = '1' then
      if std_logic'(internal_enable_state_do_0(12)) = '1' then 
        internal_state_do_0(12) <= internal_advance_to_state_do_0(12);
      end if;
    end if;

  end process;

  internal_enable_state_do_0(12) <= block_wide_enable1;
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      internal_state_do_0(13) <= std_logic'('0');
    elsif clk'event and clk = '1' then
      if std_logic'(internal_enable_state_do_0(13)) = '1' then 
        internal_state_do_0(13) <= internal_advance_to_state_do_0(13);
      end if;
    end if;

  end process;

  internal_enable_state_do_0(13) <= block_wide_enable1;
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      internal_state_do_0(14) <= std_logic'('0');
    elsif clk'event and clk = '1' then
      if std_logic'(internal_enable_state_do_0(14)) = '1' then 
        internal_state_do_0(14) <= internal_advance_to_state_do_0(14);
      end if;
    end if;

  end process;

  internal_enable_state_do_0(14) <= block_wide_enable1;
  internal_enable_state_do_0(15) <= block_wide_enable1;
  --advance_to_state_do_0[0] assign, which is an e_assign
  internal_advance_to_state_do_0(0) <= Vector_To_Std_Logic((((std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(((enable_do_dma_state0(3) AND advance_to_do_dma_state0(3)))))) AND go_bit_control_output1) AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(NOT(internal_state_do_0(0)))))));
  --advance_to_state_do_0[1] assign, which is an e_assign
  internal_advance_to_state_do_0(1) <= ((internal_state_do_0(0) OR internal_advance_to_state_do_0(2))) AND NOT((or_reduce(break1)));
  --advance_to_state_do_0[2] assign, which is an e_assign
  internal_advance_to_state_do_0(2) <= (internal_state_do_0(1)) AND NOT((or_reduce(break1)));
  --advance_to_state_do_0[3] assign, which is an e_assign
  internal_advance_to_state_do_0(3) <= internal_state_do_0(2);
  --advance_to_state_do_0[4] assign, which is an e_assign
  internal_advance_to_state_do_0(4) <= internal_state_do_0(3);
  --advance_to_state_do_0[5] assign, which is an e_assign
  internal_advance_to_state_do_0(5) <= internal_state_do_0(4);
  --advance_to_state_do_0[6] assign, which is an e_assign
  internal_advance_to_state_do_0(6) <= internal_state_do_0(5);
  --advance_to_state_do_0[7] assign, which is an e_assign
  internal_advance_to_state_do_0(7) <= internal_state_do_0(6);
  --advance_to_state_do_0[8] assign, which is an e_assign
  internal_advance_to_state_do_0(8) <= internal_state_do_0(7);
  --advance_to_state_do_0[9] assign, which is an e_assign
  internal_advance_to_state_do_0(9) <= internal_state_do_0(8);
  --advance_to_state_do_0[10] assign, which is an e_assign
  internal_advance_to_state_do_0(10) <= internal_state_do_0(9);
  --advance_to_state_do_0[11] assign, which is an e_assign
  internal_advance_to_state_do_0(11) <= internal_state_do_0(10);
  --advance_to_state_do_0[12] assign, which is an e_assign
  internal_advance_to_state_do_0(12) <= internal_state_do_0(11);
  --advance_to_state_do_0[13] assign, which is an e_assign
  internal_advance_to_state_do_0(13) <= internal_state_do_0(12);
  --advance_to_state_do_0[14] assign, which is an e_assign
  internal_advance_to_state_do_0(14) <= internal_state_do_0(13);
  --advance_to_state_do_0[15] assign, which is an e_assign
  internal_advance_to_state_do_0(15) <= internal_state_do_0(14);
  --on/inhibit register for c_do_block, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      inhibit_from_c_do_block0 <= std_logic'('0');
    elsif clk'event and clk = '1' then
      if ((break25 AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(((internal_enable_state_do_0(15) AND internal_advance_to_state_do_0(15)))))))) /= std_logic_vector'("00000000000000000000000000000000") then 
        inhibit_from_c_do_block0 <= std_logic'('0');
      elsif ((go_bit_control_output1 AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(((enable_do_dma_state0(3) AND advance_to_do_dma_state0(3)))))))) /= std_logic_vector'("00000000000000000000000000000000") then 
        inhibit_from_c_do_block0 <= Vector_To_Std_Logic(-SIGNED(std_logic_vector'("00000000000000000000000000000001")));
      end if;
    end if;

  end process;

  --block_wide_enable1 inhibitor mux, which is an e_mux
  block_wide_enable1 <= Vector_To_Std_Logic(((std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(((((NOT accelerator_DMA_tutor_do_dma_master_resource0_fifo_empty0 OR NOT (internal_state_do_0(11)))) AND accelerator_DMA_tutor_do_dma_dereferenced_source_ptr1_read0_waitrequest_n0) AND accelerator_DMA_tutor_do_dma_dereferenced_dest_ptr1_write0_waitrequest_n0)))) AND std_logic_vector'("00000000000000000000000000000001")));
  --vhdl renameroo for output signals
  advance_to_state_do_0 <= internal_advance_to_state_do_0;
  --vhdl renameroo for output signals
  enable_state_do_0 <= internal_enable_state_do_0;
  --vhdl renameroo for output signals
  state_do_0 <= internal_state_do_0;

end europa;



-- turn off superfluous VHDL processor warnings 
-- altera message_level Level1 
-- altera message_off 10034 10035 10036 10037 10230 10240 10030 

library altera;
use altera.altera_europa_support_lib.all;

library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;

entity accelerator_DMA_tutor_do_dma_master_resource0 is 
        port (
              -- inputs:
                 signal accelerator_DMA_tutor_do_dma_dereferenced_source_ptr1_read0_address2 : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                 signal accelerator_DMA_tutor_do_dma_dereferenced_source_ptr1_read0_read0 : IN STD_LOGIC;
                 signal accelerator_DMA_tutor_do_dma_master_resource0_readdata0 : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                 signal accelerator_DMA_tutor_do_dma_master_resource0_readdatavalid0 : IN STD_LOGIC;
                 signal accelerator_DMA_tutor_do_dma_master_resource0_waitrequest_n0 : IN STD_LOGIC;
                 signal advance_to_state_do_0 : IN STD_LOGIC_VECTOR (15 DOWNTO 0);
                 signal clk : IN STD_LOGIC;
                 signal enable_state_do_0 : IN STD_LOGIC_VECTOR (15 DOWNTO 0);
                 signal reset_n : IN STD_LOGIC;

              -- outputs:
                 signal accelerator_DMA_tutor_do_dma_dereferenced_source_ptr1_read0_waitrequest_n0 : OUT STD_LOGIC;
                 signal accelerator_DMA_tutor_do_dma_master_resource0_address0 : OUT STD_LOGIC_VECTOR (31 DOWNTO 0);
                 signal accelerator_DMA_tutor_do_dma_master_resource0_fifo_empty0 : OUT STD_LOGIC;
                 signal accelerator_DMA_tutor_do_dma_master_resource0_fifo_out_aligned0 : OUT STD_LOGIC_VECTOR (31 DOWNTO 0);
                 signal accelerator_DMA_tutor_do_dma_master_resource0_flush0 : OUT STD_LOGIC;
                 signal accelerator_DMA_tutor_do_dma_master_resource0_read0 : OUT STD_LOGIC
              );
end entity accelerator_DMA_tutor_do_dma_master_resource0;


architecture europa of accelerator_DMA_tutor_do_dma_master_resource0 is
  component scfifo is
GENERIC (
      lpm_numwords : NATURAL;
        lpm_showahead : STRING;
        lpm_width : NATURAL;
        lpm_widthu : NATURAL;
        use_eab : STRING
      );
    PORT (
    signal full : OUT STD_LOGIC;
        signal q : OUT STD_LOGIC_VECTOR (31 DOWNTO 0);
        signal empty : OUT STD_LOGIC;
        signal rdreq : IN STD_LOGIC;
        signal aclr : IN STD_LOGIC;
        signal data : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
        signal sclr : IN STD_LOGIC;
        signal clock : IN STD_LOGIC;
        signal wrreq : IN STD_LOGIC
      );
  end component scfifo;
                signal accelerator_DMA_tutor_do_dma_master_resource0_address_mux_out0 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal accelerator_DMA_tutor_do_dma_master_resource0_fifo_aclr0 :  STD_LOGIC;
                signal accelerator_DMA_tutor_do_dma_master_resource0_fifo_full0 :  STD_LOGIC;
                signal accelerator_DMA_tutor_do_dma_master_resource0_fifo_out0 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal accelerator_DMA_tutor_do_dma_master_resource0_fifo_read0 :  STD_LOGIC;
                signal accelerator_DMA_tutor_do_dma_master_resource0_fifo_sclr0 :  STD_LOGIC;
                signal internal_accelerator_DMA_tutor_do_dma_master_resource0_fifo_empty0 :  STD_LOGIC;

begin

  accelerator_DMA_tutor_do_dma_dereferenced_source_ptr1_read0_waitrequest_n0 <= accelerator_DMA_tutor_do_dma_master_resource0_waitrequest_n0;
  accelerator_DMA_tutor_do_dma_master_resource0_address_mux_out0 <= A_REP(((enable_state_do_0(2) AND advance_to_state_do_0(2))) , 32) AND accelerator_DMA_tutor_do_dma_dereferenced_source_ptr1_read0_address2;
  --accelerator_DMA_tutor_do_dma_master_resource0 address register, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      accelerator_DMA_tutor_do_dma_master_resource0_address0 <= std_logic_vector'("00000000000000000000000000000000");
    elsif clk'event and clk = '1' then
      if std_logic'(accelerator_DMA_tutor_do_dma_master_resource0_waitrequest_n0) = '1' then 
        accelerator_DMA_tutor_do_dma_master_resource0_address0 <= accelerator_DMA_tutor_do_dma_master_resource0_address_mux_out0;
      end if;
    end if;

  end process;

  accelerator_DMA_tutor_do_dma_master_resource0_fifo_sclr0 <= enable_state_do_0(0) AND advance_to_state_do_0(0);
  accelerator_DMA_tutor_do_dma_master_resource0_fifo_aclr0 <= NOT reset_n;
  accelerator_DMA_tutor_do_dma_shift_fifo0 : scfifo
    generic map(
      lpm_numwords => 11,
      lpm_showahead => "ON",
      lpm_width => 32,
      lpm_widthu => 4,
      use_eab => "ON"
    )
    port map(
            aclr => accelerator_DMA_tutor_do_dma_master_resource0_fifo_aclr0,
            clock => clk,
            data => accelerator_DMA_tutor_do_dma_master_resource0_readdata0,
            empty => internal_accelerator_DMA_tutor_do_dma_master_resource0_fifo_empty0,
            full => accelerator_DMA_tutor_do_dma_master_resource0_fifo_full0,
            q => accelerator_DMA_tutor_do_dma_master_resource0_fifo_out0,
            rdreq => accelerator_DMA_tutor_do_dma_master_resource0_fifo_read0,
            sclr => accelerator_DMA_tutor_do_dma_master_resource0_fifo_sclr0,
            wrreq => accelerator_DMA_tutor_do_dma_master_resource0_readdatavalid0
    );

  accelerator_DMA_tutor_do_dma_master_resource0_flush0 <= enable_state_do_0(0) AND advance_to_state_do_0(0);
  accelerator_DMA_tutor_do_dma_master_resource0_read0 <= accelerator_DMA_tutor_do_dma_dereferenced_source_ptr1_read0_read0;
  accelerator_DMA_tutor_do_dma_master_resource0_fifo_read0 <= enable_state_do_0(12) AND advance_to_state_do_0(12);
  accelerator_DMA_tutor_do_dma_master_resource0_fifo_out_aligned0 <= accelerator_DMA_tutor_do_dma_master_resource0_fifo_out0;
  --vhdl renameroo for output signals
  accelerator_DMA_tutor_do_dma_master_resource0_fifo_empty0 <= internal_accelerator_DMA_tutor_do_dma_master_resource0_fifo_empty0;

end europa;



-- turn off superfluous VHDL processor warnings 
-- altera message_level Level1 
-- altera message_off 10034 10035 10036 10037 10230 10240 10030 

library altera;
use altera.altera_europa_support_lib.all;

library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;

entity accelerator_DMA_tutor_do_dma_master_resource1 is 
        port (
              -- inputs:
                 signal accelerator_DMA_tutor_do_dma_dereferenced_dest_ptr1_write0_address2 : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                 signal accelerator_DMA_tutor_do_dma_dereferenced_dest_ptr1_write0_write0 : IN STD_LOGIC;
                 signal accelerator_DMA_tutor_do_dma_dereferenced_dest_ptr1_write0_writedata0 : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                 signal accelerator_DMA_tutor_do_dma_master_resource1_waitrequest_n0 : IN STD_LOGIC;
                 signal advance_to_state_do_0 : IN STD_LOGIC_VECTOR (15 DOWNTO 0);
                 signal clk : IN STD_LOGIC;
                 signal enable_state_do_0 : IN STD_LOGIC_VECTOR (15 DOWNTO 0);
                 signal go_bit_control_output5 : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                 signal reset_n : IN STD_LOGIC;

              -- outputs:
                 signal accelerator_DMA_tutor_do_dma_dereferenced_dest_ptr1_write0_waitrequest_n0 : OUT STD_LOGIC;
                 signal accelerator_DMA_tutor_do_dma_master_resource1_address0 : OUT STD_LOGIC_VECTOR (31 DOWNTO 0);
                 signal accelerator_DMA_tutor_do_dma_master_resource1_byteenable0 : OUT STD_LOGIC_VECTOR (3 DOWNTO 0);
                 signal accelerator_DMA_tutor_do_dma_master_resource1_write0 : OUT STD_LOGIC;
                 signal accelerator_DMA_tutor_do_dma_master_resource1_writedata0 : OUT STD_LOGIC_VECTOR (31 DOWNTO 0)
              );
end entity accelerator_DMA_tutor_do_dma_master_resource1;


architecture europa of accelerator_DMA_tutor_do_dma_master_resource1 is
                signal accelerator_DMA_tutor_do_dma_master_resource1_address_mux_out0 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal accelerator_DMA_tutor_do_dma_master_resource1_byteenable_mux_out0 :  STD_LOGIC_VECTOR (3 DOWNTO 0);
                signal accelerator_DMA_tutor_do_dma_master_resource1_byteenable_shifted0 :  STD_LOGIC_VECTOR (3 DOWNTO 0);
                signal accelerator_DMA_tutor_do_dma_master_resource1_writedata_mux_out0 :  STD_LOGIC_VECTOR (31 DOWNTO 0);

begin

  accelerator_DMA_tutor_do_dma_dereferenced_dest_ptr1_write0_waitrequest_n0 <= accelerator_DMA_tutor_do_dma_master_resource1_waitrequest_n0;
  accelerator_DMA_tutor_do_dma_master_resource1_address_mux_out0 <= A_REP(((((enable_state_do_0(13) AND advance_to_state_do_0(13))) AND go_bit_control_output5(0))) , 32) AND accelerator_DMA_tutor_do_dma_dereferenced_dest_ptr1_write0_address2;
  --accelerator_DMA_tutor_do_dma_master_resource1 address register, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      accelerator_DMA_tutor_do_dma_master_resource1_address0 <= std_logic_vector'("00000000000000000000000000000000");
    elsif clk'event and clk = '1' then
      if std_logic'(accelerator_DMA_tutor_do_dma_master_resource1_waitrequest_n0) = '1' then 
        accelerator_DMA_tutor_do_dma_master_resource1_address0 <= accelerator_DMA_tutor_do_dma_master_resource1_address_mux_out0;
      end if;
    end if;

  end process;

  accelerator_DMA_tutor_do_dma_master_resource1_writedata_mux_out0 <= A_REP(((((enable_state_do_0(13) AND advance_to_state_do_0(13))) AND go_bit_control_output5(0))) , 32) AND accelerator_DMA_tutor_do_dma_dereferenced_dest_ptr1_write0_writedata0;
  --accelerator_DMA_tutor_do_dma_master_resource1 writedata register, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      accelerator_DMA_tutor_do_dma_master_resource1_writedata0 <= std_logic_vector'("00000000000000000000000000000000");
    elsif clk'event and clk = '1' then
      if std_logic'(accelerator_DMA_tutor_do_dma_master_resource1_waitrequest_n0) = '1' then 
        accelerator_DMA_tutor_do_dma_master_resource1_writedata0 <= accelerator_DMA_tutor_do_dma_master_resource1_writedata_mux_out0;
      end if;
    end if;

  end process;

  accelerator_DMA_tutor_do_dma_master_resource1_write0 <= accelerator_DMA_tutor_do_dma_dereferenced_dest_ptr1_write0_write0;
  accelerator_DMA_tutor_do_dma_master_resource1_byteenable_mux_out0 <= A_REP(((((enable_state_do_0(13) AND advance_to_state_do_0(13))) AND go_bit_control_output5(0))) , 4) AND std_logic_vector'("1111");
  accelerator_DMA_tutor_do_dma_master_resource1_byteenable_shifted0 <= accelerator_DMA_tutor_do_dma_master_resource1_byteenable_mux_out0;
  --accelerator_DMA_tutor_do_dma_master_resource1 byteenable register, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      accelerator_DMA_tutor_do_dma_master_resource1_byteenable0 <= std_logic_vector'("0000");
    elsif clk'event and clk = '1' then
      if std_logic'(accelerator_DMA_tutor_do_dma_master_resource1_waitrequest_n0) = '1' then 
        accelerator_DMA_tutor_do_dma_master_resource1_byteenable0 <= accelerator_DMA_tutor_do_dma_master_resource1_byteenable_shifted0;
      end if;
    end if;

  end process;


end europa;



-- turn off superfluous VHDL processor warnings 
-- altera message_level Level1 
-- altera message_off 10034 10035 10036 10037 10230 10240 10030 

library altera;
use altera.altera_europa_support_lib.all;

library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;

--c_pointer_dereference module for ../dma_c2h_tutorial.c:
--*dest_ptr++ = *source_ptr++;
--Connections: cpu_0/jtag_debug_module(1), onchip_memory2_0/s1(1), sdram_0/s1(1)
entity accelerator_DMA_tutor_do_dma_dereferenced_source_ptr1_read0_module0 is 
        port (
              -- inputs:
                 signal accelerator_DMA_tutor_do_dma_dereferenced_source_ptr1_read0_address1 : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                 signal accelerator_DMA_tutor_do_dma_dereferenced_source_ptr1_read0_waitrequest_n0 : IN STD_LOGIC;
                 signal advance_to_state_do_0 : IN STD_LOGIC_VECTOR (15 DOWNTO 0);
                 signal clk : IN STD_LOGIC;
                 signal enable_state_do_0 : IN STD_LOGIC_VECTOR (15 DOWNTO 0);
                 signal reset_n : IN STD_LOGIC;

              -- outputs:
                 signal accelerator_DMA_tutor_do_dma_dereferenced_source_ptr1_read0_address2 : OUT STD_LOGIC_VECTOR (31 DOWNTO 0);
                 signal accelerator_DMA_tutor_do_dma_dereferenced_source_ptr1_read0_read0 : OUT STD_LOGIC
              );
end entity accelerator_DMA_tutor_do_dma_dereferenced_source_ptr1_read0_module0;


architecture europa of accelerator_DMA_tutor_do_dma_dereferenced_source_ptr1_read0_module0 is

begin

  accelerator_DMA_tutor_do_dma_dereferenced_source_ptr1_read0_address2 <= accelerator_DMA_tutor_do_dma_dereferenced_source_ptr1_read0_address1;
  --read is set by the previous state enable
  --and reset by no ~accelerator_DMA_tutor_do_dma_dereferenced_source_ptr1_read0_waitrequest_n0
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      accelerator_DMA_tutor_do_dma_dereferenced_source_ptr1_read0_read0 <= std_logic'('0');
    elsif clk'event and clk = '1' then
      if std_logic'((enable_state_do_0(2) AND advance_to_state_do_0(2))) = '1' then 
        accelerator_DMA_tutor_do_dma_dereferenced_source_ptr1_read0_read0 <= Vector_To_Std_Logic(-SIGNED(std_logic_vector'("00000000000000000000000000000001")));
      elsif std_logic'(accelerator_DMA_tutor_do_dma_dereferenced_source_ptr1_read0_waitrequest_n0) = '1' then 
        accelerator_DMA_tutor_do_dma_dereferenced_source_ptr1_read0_read0 <= std_logic'('0');
      end if;
    end if;

  end process;


end europa;



-- turn off superfluous VHDL processor warnings 
-- altera message_level Level1 
-- altera message_off 10034 10035 10036 10037 10230 10240 10030 

library altera;
use altera.altera_europa_support_lib.all;

library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;

--c_pointer_dereference module for ../dma_c2h_tutorial.c:
--*dest_ptr++ = *source_ptr++;
--Connections: cpu_0/jtag_debug_module(1), onchip_memory2_0/s1(1), sdram_0/s1(1)
entity accelerator_DMA_tutor_do_dma_dereferenced_dest_ptr1_write0_module0 is 
        port (
              -- inputs:
                 signal accelerator_DMA_tutor_do_dma_dereferenced_dest_ptr1_write0_address1 : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                 signal accelerator_DMA_tutor_do_dma_dereferenced_dest_ptr1_write0_waitrequest_n0 : IN STD_LOGIC;
                 signal advance_to_state_do_0 : IN STD_LOGIC_VECTOR (15 DOWNTO 0);
                 signal clk : IN STD_LOGIC;
                 signal dereferenced_dest_ptr2 : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                 signal enable_state_do_0 : IN STD_LOGIC_VECTOR (15 DOWNTO 0);
                 signal go_bit_control_output5 : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                 signal reset_n : IN STD_LOGIC;

              -- outputs:
                 signal accelerator_DMA_tutor_do_dma_dereferenced_dest_ptr1_write0_address2 : OUT STD_LOGIC_VECTOR (31 DOWNTO 0);
                 signal accelerator_DMA_tutor_do_dma_dereferenced_dest_ptr1_write0_write0 : OUT STD_LOGIC;
                 signal accelerator_DMA_tutor_do_dma_dereferenced_dest_ptr1_write0_writedata0 : OUT STD_LOGIC_VECTOR (31 DOWNTO 0)
              );
end entity accelerator_DMA_tutor_do_dma_dereferenced_dest_ptr1_write0_module0;


architecture europa of accelerator_DMA_tutor_do_dma_dereferenced_dest_ptr1_write0_module0 is

begin

  accelerator_DMA_tutor_do_dma_dereferenced_dest_ptr1_write0_address2 <= accelerator_DMA_tutor_do_dma_dereferenced_dest_ptr1_write0_address1;
  --write is set by the previous state enable
  --and reset by no ~accelerator_DMA_tutor_do_dma_dereferenced_dest_ptr1_write0_waitrequest_n0
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      accelerator_DMA_tutor_do_dma_dereferenced_dest_ptr1_write0_write0 <= std_logic'('0');
    elsif clk'event and clk = '1' then
      if std_logic'((((enable_state_do_0(13) AND advance_to_state_do_0(13))) AND go_bit_control_output5(0))) = '1' then 
        accelerator_DMA_tutor_do_dma_dereferenced_dest_ptr1_write0_write0 <= Vector_To_Std_Logic(-SIGNED(std_logic_vector'("00000000000000000000000000000001")));
      elsif std_logic'(accelerator_DMA_tutor_do_dma_dereferenced_dest_ptr1_write0_waitrequest_n0) = '1' then 
        accelerator_DMA_tutor_do_dma_dereferenced_dest_ptr1_write0_write0 <= std_logic'('0');
      end if;
    end if;

  end process;

  accelerator_DMA_tutor_do_dma_dereferenced_dest_ptr1_write0_writedata0 <= dereferenced_dest_ptr2;

end europa;



-- turn off superfluous VHDL processor warnings 
-- altera message_level Level1 
-- altera message_off 10034 10035 10036 10037 10230 10240 10030 

library altera;
use altera.altera_europa_support_lib.all;

library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;

entity accelerator_DMA_tutor_do_dma_do_dma0 is 
        port (
              -- inputs:
                 signal accelerator_DMA_tutor_do_dma_master_resource0_readdata0 : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                 signal accelerator_DMA_tutor_do_dma_master_resource0_readdatavalid0 : IN STD_LOGIC;
                 signal accelerator_DMA_tutor_do_dma_master_resource0_waitrequest_n0 : IN STD_LOGIC;
                 signal accelerator_DMA_tutor_do_dma_master_resource1_waitrequest_n0 : IN STD_LOGIC;
                 signal clk : IN STD_LOGIC;
                 signal do_dma_begin0 : IN STD_LOGIC;
                 signal do_dma_functiondata0 : IN STD_LOGIC_VECTOR (95 DOWNTO 0);
                 signal do_dma_read0 : IN STD_LOGIC;
                 signal do_dma_select0 : IN STD_LOGIC;
                 signal reset_n : IN STD_LOGIC;

              -- outputs:
                 signal accelerator_DMA_tutor_do_dma_master_resource0_address0 : OUT STD_LOGIC_VECTOR (31 DOWNTO 0);
                 signal accelerator_DMA_tutor_do_dma_master_resource0_flush0 : OUT STD_LOGIC;
                 signal accelerator_DMA_tutor_do_dma_master_resource0_read0 : OUT STD_LOGIC;
                 signal accelerator_DMA_tutor_do_dma_master_resource1_address0 : OUT STD_LOGIC_VECTOR (31 DOWNTO 0);
                 signal accelerator_DMA_tutor_do_dma_master_resource1_byteenable0 : OUT STD_LOGIC_VECTOR (3 DOWNTO 0);
                 signal accelerator_DMA_tutor_do_dma_master_resource1_write0 : OUT STD_LOGIC;
                 signal accelerator_DMA_tutor_do_dma_master_resource1_writedata0 : OUT STD_LOGIC_VECTOR (31 DOWNTO 0);
                 signal cpu_readdata0 : OUT STD_LOGIC_VECTOR (31 DOWNTO 0);
                 signal do_dma_waitrequest_n0 : OUT STD_LOGIC
              );
end entity accelerator_DMA_tutor_do_dma_do_dma0;


architecture europa of accelerator_DMA_tutor_do_dma_do_dma0 is
component accelerator_DMA_tutor_do_dma_do_dma0_state_machine_subroutine_0 is 
           port (
                 -- inputs:
                    signal clk : IN STD_LOGIC;
                    signal do_dma_begin0 : IN STD_LOGIC;
                    signal do_dma_read0 : IN STD_LOGIC;
                    signal do_dma_select0 : IN STD_LOGIC;
                    signal inhibit_from_c_do_block0 : IN STD_LOGIC;
                    signal reset_n : IN STD_LOGIC;

                 -- outputs:
                    signal advance_to_do_dma_state0 : OUT STD_LOGIC_VECTOR (5 DOWNTO 0);
                    signal do_dma_state0 : OUT STD_LOGIC_VECTOR (5 DOWNTO 0);
                    signal enable_do_dma_state0 : OUT STD_LOGIC_VECTOR (5 DOWNTO 0)
                 );
end component accelerator_DMA_tutor_do_dma_do_dma0_state_machine_subroutine_0;

component accelerator_DMA_tutor_do_dma_do_dma0_state_machine_do_0 is 
           port (
                 -- inputs:
                    signal accelerator_DMA_tutor_do_dma_dereferenced_dest_ptr1_write0_waitrequest_n0 : IN STD_LOGIC;
                    signal accelerator_DMA_tutor_do_dma_dereferenced_source_ptr1_read0_waitrequest_n0 : IN STD_LOGIC;
                    signal accelerator_DMA_tutor_do_dma_master_resource0_fifo_empty0 : IN STD_LOGIC;
                    signal advance_to_do_dma_state0 : IN STD_LOGIC_VECTOR (5 DOWNTO 0);
                    signal break1 : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                    signal break25 : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                    signal clk : IN STD_LOGIC;
                    signal enable_do_dma_state0 : IN STD_LOGIC_VECTOR (5 DOWNTO 0);
                    signal go_bit_control_output1 : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                    signal reset_n : IN STD_LOGIC;

                 -- outputs:
                    signal advance_to_state_do_0 : OUT STD_LOGIC_VECTOR (15 DOWNTO 0);
                    signal enable_state_do_0 : OUT STD_LOGIC_VECTOR (15 DOWNTO 0);
                    signal inhibit_from_c_do_block0 : OUT STD_LOGIC;
                    signal state_do_0 : OUT STD_LOGIC_VECTOR (15 DOWNTO 0)
                 );
end component accelerator_DMA_tutor_do_dma_do_dma0_state_machine_do_0;

component accelerator_DMA_tutor_do_dma_master_resource0 is 
           port (
                 -- inputs:
                    signal accelerator_DMA_tutor_do_dma_dereferenced_source_ptr1_read0_address2 : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                    signal accelerator_DMA_tutor_do_dma_dereferenced_source_ptr1_read0_read0 : IN STD_LOGIC;
                    signal accelerator_DMA_tutor_do_dma_master_resource0_readdata0 : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                    signal accelerator_DMA_tutor_do_dma_master_resource0_readdatavalid0 : IN STD_LOGIC;
                    signal accelerator_DMA_tutor_do_dma_master_resource0_waitrequest_n0 : IN STD_LOGIC;
                    signal advance_to_state_do_0 : IN STD_LOGIC_VECTOR (15 DOWNTO 0);
                    signal clk : IN STD_LOGIC;
                    signal enable_state_do_0 : IN STD_LOGIC_VECTOR (15 DOWNTO 0);
                    signal reset_n : IN STD_LOGIC;

                 -- outputs:
                    signal accelerator_DMA_tutor_do_dma_dereferenced_source_ptr1_read0_waitrequest_n0 : OUT STD_LOGIC;
                    signal accelerator_DMA_tutor_do_dma_master_resource0_address0 : OUT STD_LOGIC_VECTOR (31 DOWNTO 0);
                    signal accelerator_DMA_tutor_do_dma_master_resource0_fifo_empty0 : OUT STD_LOGIC;
                    signal accelerator_DMA_tutor_do_dma_master_resource0_fifo_out_aligned0 : OUT STD_LOGIC_VECTOR (31 DOWNTO 0);
                    signal accelerator_DMA_tutor_do_dma_master_resource0_flush0 : OUT STD_LOGIC;
                    signal accelerator_DMA_tutor_do_dma_master_resource0_read0 : OUT STD_LOGIC
                 );
end component accelerator_DMA_tutor_do_dma_master_resource0;

component accelerator_DMA_tutor_do_dma_master_resource1 is 
           port (
                 -- inputs:
                    signal accelerator_DMA_tutor_do_dma_dereferenced_dest_ptr1_write0_address2 : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                    signal accelerator_DMA_tutor_do_dma_dereferenced_dest_ptr1_write0_write0 : IN STD_LOGIC;
                    signal accelerator_DMA_tutor_do_dma_dereferenced_dest_ptr1_write0_writedata0 : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                    signal accelerator_DMA_tutor_do_dma_master_resource1_waitrequest_n0 : IN STD_LOGIC;
                    signal advance_to_state_do_0 : IN STD_LOGIC_VECTOR (15 DOWNTO 0);
                    signal clk : IN STD_LOGIC;
                    signal enable_state_do_0 : IN STD_LOGIC_VECTOR (15 DOWNTO 0);
                    signal go_bit_control_output5 : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                    signal reset_n : IN STD_LOGIC;

                 -- outputs:
                    signal accelerator_DMA_tutor_do_dma_dereferenced_dest_ptr1_write0_waitrequest_n0 : OUT STD_LOGIC;
                    signal accelerator_DMA_tutor_do_dma_master_resource1_address0 : OUT STD_LOGIC_VECTOR (31 DOWNTO 0);
                    signal accelerator_DMA_tutor_do_dma_master_resource1_byteenable0 : OUT STD_LOGIC_VECTOR (3 DOWNTO 0);
                    signal accelerator_DMA_tutor_do_dma_master_resource1_write0 : OUT STD_LOGIC;
                    signal accelerator_DMA_tutor_do_dma_master_resource1_writedata0 : OUT STD_LOGIC_VECTOR (31 DOWNTO 0)
                 );
end component accelerator_DMA_tutor_do_dma_master_resource1;

component accelerator_DMA_tutor_do_dma_dereferenced_source_ptr1_read0_module0 is 
           port (
                 -- inputs:
                    signal accelerator_DMA_tutor_do_dma_dereferenced_source_ptr1_read0_address1 : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                    signal accelerator_DMA_tutor_do_dma_dereferenced_source_ptr1_read0_waitrequest_n0 : IN STD_LOGIC;
                    signal advance_to_state_do_0 : IN STD_LOGIC_VECTOR (15 DOWNTO 0);
                    signal clk : IN STD_LOGIC;
                    signal enable_state_do_0 : IN STD_LOGIC_VECTOR (15 DOWNTO 0);
                    signal reset_n : IN STD_LOGIC;

                 -- outputs:
                    signal accelerator_DMA_tutor_do_dma_dereferenced_source_ptr1_read0_address2 : OUT STD_LOGIC_VECTOR (31 DOWNTO 0);
                    signal accelerator_DMA_tutor_do_dma_dereferenced_source_ptr1_read0_read0 : OUT STD_LOGIC
                 );
end component accelerator_DMA_tutor_do_dma_dereferenced_source_ptr1_read0_module0;

component accelerator_DMA_tutor_do_dma_dereferenced_dest_ptr1_write0_module0 is 
           port (
                 -- inputs:
                    signal accelerator_DMA_tutor_do_dma_dereferenced_dest_ptr1_write0_address1 : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                    signal accelerator_DMA_tutor_do_dma_dereferenced_dest_ptr1_write0_waitrequest_n0 : IN STD_LOGIC;
                    signal advance_to_state_do_0 : IN STD_LOGIC_VECTOR (15 DOWNTO 0);
                    signal clk : IN STD_LOGIC;
                    signal dereferenced_dest_ptr2 : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                    signal enable_state_do_0 : IN STD_LOGIC_VECTOR (15 DOWNTO 0);
                    signal go_bit_control_output5 : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                    signal reset_n : IN STD_LOGIC;

                 -- outputs:
                    signal accelerator_DMA_tutor_do_dma_dereferenced_dest_ptr1_write0_address2 : OUT STD_LOGIC_VECTOR (31 DOWNTO 0);
                    signal accelerator_DMA_tutor_do_dma_dereferenced_dest_ptr1_write0_write0 : OUT STD_LOGIC;
                    signal accelerator_DMA_tutor_do_dma_dereferenced_dest_ptr1_write0_writedata0 : OUT STD_LOGIC_VECTOR (31 DOWNTO 0)
                 );
end component accelerator_DMA_tutor_do_dma_dereferenced_dest_ptr1_write0_module0;

                signal accelerator_DMA_tutor_do_dma_dereferenced_dest_ptr1_write0_address1 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal accelerator_DMA_tutor_do_dma_dereferenced_dest_ptr1_write0_address2 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal accelerator_DMA_tutor_do_dma_dereferenced_dest_ptr1_write0_waitrequest_n0 :  STD_LOGIC;
                signal accelerator_DMA_tutor_do_dma_dereferenced_dest_ptr1_write0_write0 :  STD_LOGIC;
                signal accelerator_DMA_tutor_do_dma_dereferenced_dest_ptr1_write0_writedata0 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal accelerator_DMA_tutor_do_dma_dereferenced_source_ptr1_read0_address1 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal accelerator_DMA_tutor_do_dma_dereferenced_source_ptr1_read0_address2 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal accelerator_DMA_tutor_do_dma_dereferenced_source_ptr1_read0_read0 :  STD_LOGIC;
                signal accelerator_DMA_tutor_do_dma_dereferenced_source_ptr1_read0_waitrequest_n0 :  STD_LOGIC;
                signal accelerator_DMA_tutor_do_dma_master_resource0_fifo_empty0 :  STD_LOGIC;
                signal accelerator_DMA_tutor_do_dma_master_resource0_fifo_out_aligned0 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal advance_to_do_dma_state0 :  STD_LOGIC_VECTOR (5 DOWNTO 0);
                signal advance_to_state_do_0 :  STD_LOGIC_VECTOR (15 DOWNTO 0);
                signal auto0 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal break0 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal break1 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal break10 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal break11 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal break12 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal break13 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal break14 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal break15 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal break16 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal break17 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal break18 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal break19 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal break2 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal break20 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal break21 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal break22 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal break23 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal break24 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal break25 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal break3 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal break4 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal break5 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal break6 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal break7 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal break8 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal break9 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal continue0 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal control_output_break1 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal control_output_if1 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal dereferenced_dest_ptr2 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal dereferenced_source_ptr2 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal dest_ptr0 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal dest_ptr10 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal dest_ptr11 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal dest_ptr12 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal dest_ptr13 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal dest_ptr14 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal dest_ptr15 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal dest_ptr16 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal dest_ptr17 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal dest_ptr18 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal dest_ptr2 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal dest_ptr20 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal dest_ptr21 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal dest_ptr3 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal dest_ptr4 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal dest_ptr5 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal dest_ptr6 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal dest_ptr7 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal dest_ptr8 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal dest_ptr9 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal dest_ptr_init1 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal do_dma_state0 :  STD_LOGIC_VECTOR (5 DOWNTO 0);
                signal dummy_if_signal1 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal enable_do_dma_state0 :  STD_LOGIC_VECTOR (5 DOWNTO 0);
                signal enable_state_do_0 :  STD_LOGIC_VECTOR (15 DOWNTO 0);
                signal first_time_at_clock_0_state_do_1 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal first_time_at_clock_13_state_do_1 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal go_bit_control_output1 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal go_bit_control_output5 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal go_bit_control_output7 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal i0 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal i1 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal i2 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal i3 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal i4 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal i5 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal i6 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal i8 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal i9 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal i_init1 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal if0 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal if1 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal if10 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal if11 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal if12 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal if13 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal if14 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal if2 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal if3 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal if4 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal if5 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal if6 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal if7 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal if8 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal if9 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal inhibit_from_c_do_block0 :  STD_LOGIC;
                signal internal_accelerator_DMA_tutor_do_dma_master_resource0_address1 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal internal_accelerator_DMA_tutor_do_dma_master_resource0_flush1 :  STD_LOGIC;
                signal internal_accelerator_DMA_tutor_do_dma_master_resource0_read1 :  STD_LOGIC;
                signal internal_accelerator_DMA_tutor_do_dma_master_resource1_address1 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal internal_accelerator_DMA_tutor_do_dma_master_resource1_byteenable1 :  STD_LOGIC_VECTOR (3 DOWNTO 0);
                signal internal_accelerator_DMA_tutor_do_dma_master_resource1_write1 :  STD_LOGIC;
                signal internal_accelerator_DMA_tutor_do_dma_master_resource1_writedata1 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal length0 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal return0 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal return1 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal signal0 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal signal1 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal source_ptr0 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal source_ptr10 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal source_ptr11 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal source_ptr12 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal source_ptr13 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal source_ptr14 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal source_ptr15 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal source_ptr16 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal source_ptr17 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal source_ptr18 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal source_ptr2 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal source_ptr20 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal source_ptr21 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal source_ptr3 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal source_ptr4 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal source_ptr5 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal source_ptr6 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal source_ptr7 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal source_ptr8 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal source_ptr9 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal source_ptr_init1 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal state_do_0 :  STD_LOGIC_VECTOR (15 DOWNTO 0);
                signal subexp0 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal subexp1 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal subexp10 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal subexp11 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal subexp12 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal subexp13 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal subexp14 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal subexp15 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal subexp16 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal subexp17 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal subexp18 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal subexp19 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal subexp2 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal subexp20 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal subexp3 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal subexp4 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal subexp5 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal subexp6 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal subexp7 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal subexp8 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal subexp9 :  STD_LOGIC_VECTOR (31 DOWNTO 0);

begin

  cpu_readdata0 <= auto0;
  do_dma_waitrequest_n0 <= enable_do_dma_state0(5) AND advance_to_do_dma_state0(5);
  --c_subroutine_block
  accelerator_DMA_tutor_do_dma_do_dma0_the_state_machine_subroutine_0 : accelerator_DMA_tutor_do_dma_do_dma0_state_machine_subroutine_0
    port map(
      advance_to_do_dma_state0 => advance_to_do_dma_state0,
      do_dma_state0 => do_dma_state0,
      enable_do_dma_state0 => enable_do_dma_state0,
      clk => clk,
      do_dma_begin0 => do_dma_begin0,
      do_dma_read0 => do_dma_read0,
      do_dma_select0 => do_dma_select0,
      inhibit_from_c_do_block0 => inhibit_from_c_do_block0,
      reset_n => reset_n
    );


  auto0 <= std_logic_vector'("00000000000000000000000000000000");
  signal0 <= A_REP(length0(31) , 2) & length0(31 DOWNTO 2);
  subexp0 <= std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(to_std_logic((Std_Logic_Vector'(A_ToStdLogicVector(NOT i1(31)) & i1(30 DOWNTO 0))<Std_Logic_Vector'(A_ToStdLogicVector(NOT signal0(31)) & signal0(30 DOWNTO 0))))));
  subexp1 <= std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(to_std_logic((subexp0 /= std_logic_vector'("00000000000000000000000000000000")))));
  control_output_if1 <= subexp1;
  dummy_if_signal1 <= if0;
  -- e_assignment on clock 0 for ../dma_c2h_tutorial.c:
  --for( i = 0; i < (length >> 2); i++ )
  i1 <= std_logic_vector'("00000000000000000000000000000000");
  i0 <= std_logic_vector'("00000000000000000000000000000000");
  -- e_assignment on clock 0 for ../dma_c2h_tutorial.c:
  --int do_dma( int * restrict dest_ptr, int * restrict source_ptr, int length )
  if0 <= std_logic_vector'("00000000000000000000000000000001");
  -- e_assignment on clock 0 for ../dma_c2h_tutorial.c:
  --int do_dma( int * restrict dest_ptr, int * restrict source_ptr, int length )
  return0 <= std_logic_vector'("00000000000000000000000000000000");
  (dest_ptr0(31), dest_ptr0(30), dest_ptr0(29), dest_ptr0(28), dest_ptr0(27), dest_ptr0(26), dest_ptr0(25), dest_ptr0(24), dest_ptr0(23), dest_ptr0(22), dest_ptr0(21), dest_ptr0(20), dest_ptr0(19), dest_ptr0(18), dest_ptr0(17), dest_ptr0(16), dest_ptr0(15), dest_ptr0(14), dest_ptr0(13), dest_ptr0(12), dest_ptr0(11), dest_ptr0(10), dest_ptr0(9), dest_ptr0(8), dest_ptr0(7), dest_ptr0(6), dest_ptr0(5), dest_ptr0(4), dest_ptr0(3), dest_ptr0(2), dest_ptr0(1), dest_ptr0(0), source_ptr0(31), source_ptr0(30), source_ptr0(29), source_ptr0(28), source_ptr0(27), source_ptr0(26), source_ptr0(25), source_ptr0(24), source_ptr0(23), source_ptr0(22), source_ptr0(21), source_ptr0(20), source_ptr0(19), source_ptr0(18), source_ptr0(17), source_ptr0(16), source_ptr0(15), source_ptr0(14), source_ptr0(13), source_ptr0(12), source_ptr0(11), source_ptr0(10), source_ptr0(9), source_ptr0(8), source_ptr0(7), source_ptr0(6), source_ptr0(5), source_ptr0(4), source_ptr0(3), source_ptr0(2), source_ptr0(1), source_ptr0(0), length0(31), length0(30), length0(29), length0(28), length0(27), length0(26), length0(25), length0(24), length0(23), length0(22), length0(21), length0(20), length0(19), length0(18), length0(17), length0(16), length0(15), length0(14), length0(13), length0(12), length0(11), length0(10), length0(9), length0(8), length0(7), length0(6), length0(5), length0(4), length0(3), length0(2), length0(1), length0(0)) <= do_dma_functiondata0;
  subexp2 <= std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(NOT(or_reduce(return1))));
  subexp3 <= std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR((or_reduce(subexp2) AND or_reduce(if0))));
  -- e_assignment on clock 0 for ../dma_c2h_tutorial.c:
  --return( 0 );
  go_bit_control_output7 <= subexp3;
  subexp4 <= std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(NOT(or_reduce(return0))));
  subexp5 <= std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR((or_reduce(control_output_if1) AND or_reduce(subexp4))));
  subexp6 <= std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR((or_reduce(if1) AND or_reduce(dummy_if_signal1))));
  subexp7 <= std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(NOT(or_reduce(return0))));
  subexp8 <= std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR((or_reduce(subexp7) AND or_reduce(if2))));
  -- e_assignment on clock 2 for ../dma_c2h_tutorial.c:
  --{
  go_bit_control_output1 <= subexp8;
  --c_do_block
  accelerator_DMA_tutor_do_dma_do_dma0_the_state_machine_do_0 : accelerator_DMA_tutor_do_dma_do_dma0_state_machine_do_0
    port map(
      advance_to_state_do_0 => advance_to_state_do_0,
      enable_state_do_0 => enable_state_do_0,
      inhibit_from_c_do_block0 => inhibit_from_c_do_block0,
      state_do_0 => state_do_0,
      accelerator_DMA_tutor_do_dma_dereferenced_dest_ptr1_write0_waitrequest_n0 => accelerator_DMA_tutor_do_dma_dereferenced_dest_ptr1_write0_waitrequest_n0,
      accelerator_DMA_tutor_do_dma_dereferenced_source_ptr1_read0_waitrequest_n0 => accelerator_DMA_tutor_do_dma_dereferenced_source_ptr1_read0_waitrequest_n0,
      accelerator_DMA_tutor_do_dma_master_resource0_fifo_empty0 => accelerator_DMA_tutor_do_dma_master_resource0_fifo_empty0,
      advance_to_do_dma_state0 => advance_to_do_dma_state0,
      break1 => break1,
      break25 => break25,
      clk => clk,
      enable_do_dma_state0 => enable_do_dma_state0,
      go_bit_control_output1 => go_bit_control_output1,
      reset_n => reset_n
    );


  dest_ptr_init1 <= dest_ptr0;
  i_init1 <= i1;
  source_ptr_init1 <= source_ptr0;
  --the_accelerator_DMA_tutor_do_dma_master_resource0, which is an e_instance
  the_accelerator_DMA_tutor_do_dma_master_resource0 : accelerator_DMA_tutor_do_dma_master_resource0
    port map(
      accelerator_DMA_tutor_do_dma_dereferenced_source_ptr1_read0_waitrequest_n0 => accelerator_DMA_tutor_do_dma_dereferenced_source_ptr1_read0_waitrequest_n0,
      accelerator_DMA_tutor_do_dma_master_resource0_address0 => internal_accelerator_DMA_tutor_do_dma_master_resource0_address1,
      accelerator_DMA_tutor_do_dma_master_resource0_fifo_empty0 => accelerator_DMA_tutor_do_dma_master_resource0_fifo_empty0,
      accelerator_DMA_tutor_do_dma_master_resource0_fifo_out_aligned0 => accelerator_DMA_tutor_do_dma_master_resource0_fifo_out_aligned0,
      accelerator_DMA_tutor_do_dma_master_resource0_flush0 => internal_accelerator_DMA_tutor_do_dma_master_resource0_flush1,
      accelerator_DMA_tutor_do_dma_master_resource0_read0 => internal_accelerator_DMA_tutor_do_dma_master_resource0_read1,
      accelerator_DMA_tutor_do_dma_dereferenced_source_ptr1_read0_address2 => accelerator_DMA_tutor_do_dma_dereferenced_source_ptr1_read0_address2,
      accelerator_DMA_tutor_do_dma_dereferenced_source_ptr1_read0_read0 => accelerator_DMA_tutor_do_dma_dereferenced_source_ptr1_read0_read0,
      accelerator_DMA_tutor_do_dma_master_resource0_readdata0 => accelerator_DMA_tutor_do_dma_master_resource0_readdata0,
      accelerator_DMA_tutor_do_dma_master_resource0_readdatavalid0 => accelerator_DMA_tutor_do_dma_master_resource0_readdatavalid0,
      accelerator_DMA_tutor_do_dma_master_resource0_waitrequest_n0 => accelerator_DMA_tutor_do_dma_master_resource0_waitrequest_n0,
      advance_to_state_do_0 => advance_to_state_do_0,
      clk => clk,
      enable_state_do_0 => enable_state_do_0,
      reset_n => reset_n
    );


  --the_accelerator_DMA_tutor_do_dma_master_resource1, which is an e_instance
  the_accelerator_DMA_tutor_do_dma_master_resource1 : accelerator_DMA_tutor_do_dma_master_resource1
    port map(
      accelerator_DMA_tutor_do_dma_dereferenced_dest_ptr1_write0_waitrequest_n0 => accelerator_DMA_tutor_do_dma_dereferenced_dest_ptr1_write0_waitrequest_n0,
      accelerator_DMA_tutor_do_dma_master_resource1_address0 => internal_accelerator_DMA_tutor_do_dma_master_resource1_address1,
      accelerator_DMA_tutor_do_dma_master_resource1_byteenable0 => internal_accelerator_DMA_tutor_do_dma_master_resource1_byteenable1,
      accelerator_DMA_tutor_do_dma_master_resource1_write0 => internal_accelerator_DMA_tutor_do_dma_master_resource1_write1,
      accelerator_DMA_tutor_do_dma_master_resource1_writedata0 => internal_accelerator_DMA_tutor_do_dma_master_resource1_writedata1,
      accelerator_DMA_tutor_do_dma_dereferenced_dest_ptr1_write0_address2 => accelerator_DMA_tutor_do_dma_dereferenced_dest_ptr1_write0_address2,
      accelerator_DMA_tutor_do_dma_dereferenced_dest_ptr1_write0_write0 => accelerator_DMA_tutor_do_dma_dereferenced_dest_ptr1_write0_write0,
      accelerator_DMA_tutor_do_dma_dereferenced_dest_ptr1_write0_writedata0 => accelerator_DMA_tutor_do_dma_dereferenced_dest_ptr1_write0_writedata0,
      accelerator_DMA_tutor_do_dma_master_resource1_waitrequest_n0 => accelerator_DMA_tutor_do_dma_master_resource1_waitrequest_n0,
      advance_to_state_do_0 => advance_to_state_do_0,
      clk => clk,
      enable_state_do_0 => enable_state_do_0,
      go_bit_control_output5 => go_bit_control_output5,
      reset_n => reset_n
    );


  dest_ptr4 <= dest_ptr3;
  i4 <= i3;
  source_ptr4 <= source_ptr3;
  subexp9 <= A_EXT (((std_logic_vector'("0") & (dest_ptr4)) + std_logic_vector'("000000000000000000000000000000100")), 32);
  subexp10 <= A_EXT (((std_logic_vector'("0") & (i4)) + std_logic_vector'("000000000000000000000000000000001")), 32);
  subexp11 <= A_EXT (((std_logic_vector'("0") & (source_ptr4)) + std_logic_vector'("000000000000000000000000000000100")), 32);
  -- e_assignment on clock 1 for ../dma_c2h_tutorial.c:
  --*dest_ptr++ = *source_ptr++;
  accelerator_DMA_tutor_do_dma_dereferenced_source_ptr1_read0_address1 <= source_ptr5;
  -- e_assignment on clock 1 for ../dma_c2h_tutorial.c:
  --{
  break0 <= std_logic_vector'("00000000000000000000000000000000");
  signal1 <= A_REP(length0(31) , 2) & length0(31 DOWNTO 2);
  subexp12 <= std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(to_std_logic((Std_Logic_Vector'(A_ToStdLogicVector(NOT i2(31)) & i2(30 DOWNTO 0))<Std_Logic_Vector'(A_ToStdLogicVector(NOT signal1(31)) & signal1(30 DOWNTO 0))))));
  subexp13 <= std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(to_std_logic((subexp12 = std_logic_vector'("00000000000000000000000000000000")))));
  -- e_assignment on clock 1 for ../dma_c2h_tutorial.c:
  --{
  control_output_break1 <= subexp13;
  dest_ptr3 <= A_WE_StdLogicVector(((first_time_at_clock_0_state_do_1) /= std_logic_vector'("00000000000000000000000000000000")), dest_ptr_init1, dest_ptr2);
  i3 <= A_WE_StdLogicVector(((first_time_at_clock_0_state_do_1) /= std_logic_vector'("00000000000000000000000000000000")), i_init1, i2);
  -- e_assignment on clock 1 for ../dma_c2h_tutorial.c:
  --{
  if3 <= std_logic_vector'("00000000000000000000000000000001");
  source_ptr3 <= A_WE_StdLogicVector(((first_time_at_clock_0_state_do_1) /= std_logic_vector'("00000000000000000000000000000000")), source_ptr_init1, source_ptr2);
  subexp14 <= std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR((or_reduce(control_output_break1) AND or_reduce(if3))));
  --the_accelerator_DMA_tutor_do_dma_dereferenced_source_ptr1_read0_module0, which is an e_instance
  the_accelerator_DMA_tutor_do_dma_dereferenced_source_ptr1_read0_module0 : accelerator_DMA_tutor_do_dma_dereferenced_source_ptr1_read0_module0
    port map(
      accelerator_DMA_tutor_do_dma_dereferenced_source_ptr1_read0_address2 => accelerator_DMA_tutor_do_dma_dereferenced_source_ptr1_read0_address2,
      accelerator_DMA_tutor_do_dma_dereferenced_source_ptr1_read0_read0 => accelerator_DMA_tutor_do_dma_dereferenced_source_ptr1_read0_read0,
      accelerator_DMA_tutor_do_dma_dereferenced_source_ptr1_read0_address1 => accelerator_DMA_tutor_do_dma_dereferenced_source_ptr1_read0_address1,
      accelerator_DMA_tutor_do_dma_dereferenced_source_ptr1_read0_waitrequest_n0 => accelerator_DMA_tutor_do_dma_dereferenced_source_ptr1_read0_waitrequest_n0,
      advance_to_state_do_0 => advance_to_state_do_0,
      clk => clk,
      enable_state_do_0 => enable_state_do_0,
      reset_n => reset_n
    );


  -- e_assignment on clock 12 for ../dma_c2h_tutorial.c:
  --*dest_ptr++ = *source_ptr++;
  accelerator_DMA_tutor_do_dma_dereferenced_dest_ptr1_write0_address1 <= dest_ptr16;
  -- e_assignment on clock 12 for ../dma_c2h_tutorial.c:
  --{
  continue0 <= std_logic_vector'("00000000000000000000000000000000");
  -- e_assignment on clock 12 for ../dma_c2h_tutorial.c:
  --*dest_ptr++ = *source_ptr++;
  dereferenced_dest_ptr2 <= dereferenced_source_ptr2;
  subexp15 <= std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(NOT(or_reduce(return0))));
  subexp16 <= std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(NOT(or_reduce(continue0))));
  subexp17 <= std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(NOT(or_reduce(break12))));
  subexp18 <= std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR((or_reduce(subexp16) AND or_reduce(subexp17))));
  subexp19 <= std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR((or_reduce(if14) AND or_reduce(subexp18))));
  subexp20 <= std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR((or_reduce(subexp15) AND or_reduce(subexp19))));
  -- e_assignment on clock 12 for ../dma_c2h_tutorial.c:
  --*dest_ptr++ = *source_ptr++;
  go_bit_control_output5 <= subexp20;
  --the_accelerator_DMA_tutor_do_dma_dereferenced_dest_ptr1_write0_module0, which is an e_instance
  the_accelerator_DMA_tutor_do_dma_dereferenced_dest_ptr1_write0_module0 : accelerator_DMA_tutor_do_dma_dereferenced_dest_ptr1_write0_module0
    port map(
      accelerator_DMA_tutor_do_dma_dereferenced_dest_ptr1_write0_address2 => accelerator_DMA_tutor_do_dma_dereferenced_dest_ptr1_write0_address2,
      accelerator_DMA_tutor_do_dma_dereferenced_dest_ptr1_write0_write0 => accelerator_DMA_tutor_do_dma_dereferenced_dest_ptr1_write0_write0,
      accelerator_DMA_tutor_do_dma_dereferenced_dest_ptr1_write0_writedata0 => accelerator_DMA_tutor_do_dma_dereferenced_dest_ptr1_write0_writedata0,
      accelerator_DMA_tutor_do_dma_dereferenced_dest_ptr1_write0_address1 => accelerator_DMA_tutor_do_dma_dereferenced_dest_ptr1_write0_address1,
      accelerator_DMA_tutor_do_dma_dereferenced_dest_ptr1_write0_waitrequest_n0 => accelerator_DMA_tutor_do_dma_dereferenced_dest_ptr1_write0_waitrequest_n0,
      advance_to_state_do_0 => advance_to_state_do_0,
      clk => clk,
      dereferenced_dest_ptr2 => dereferenced_dest_ptr2,
      enable_state_do_0 => enable_state_do_0,
      go_bit_control_output5 => go_bit_control_output5,
      reset_n => reset_n
    );


  break25 <= A_WE_StdLogicVector(((first_time_at_clock_13_state_do_1) /= std_logic_vector'("00000000000000000000000000000000")), std_logic_vector'("00000000000000000000000000000000"), break24);
  --c_do_block longest path 1
  --due to i
  --starts at (enable_do_dma_state0[3] & advance_to_do_dma_state0[3])
  --../dma_c2h_tutorial.c:
  --{
  process (clk)
  begin
    if clk'event and clk = '1' then
      if std_logic'((enable_state_do_0(0) AND advance_to_state_do_0(0))) = '1' then 
        first_time_at_clock_0_state_do_1 <= std_logic_vector'("00000000000000000000000000000001");
        first_time_at_clock_13_state_do_1 <= std_logic_vector'("00000000000000000000000000000001");
        break1 <= std_logic_vector'("00000000000000000000000000000000");
      end if;
      if std_logic'((enable_state_do_0(1) AND advance_to_state_do_0(1))) = '1' then 
        dest_ptr2 <= subexp9;
        dest_ptr5 <= dest_ptr4;
        first_time_at_clock_0_state_do_1 <= std_logic_vector'("00000000000000000000000000000000");
        -- e_assignment on clock 0 for ../dma_c2h_tutorial.c:
        --{
        i2 <= subexp10;
        source_ptr2 <= subexp11;
        source_ptr5 <= source_ptr4;
      end if;
      if std_logic'((enable_state_do_0(2) AND advance_to_state_do_0(2))) = '1' then 
        -- e_assignment on clock 1 for ../dma_c2h_tutorial.c:
        --{
        break1 <= std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR((or_reduce((std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(((or_reduce((std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(((or_reduce(subexp14) OR or_reduce(break0))))))) OR or_reduce(return0))))))) OR or_reduce(return0))));
        break2 <= break0;
        dest_ptr6 <= dest_ptr5;
        dest_ptr17 <= dest_ptr4;
        i5 <= i4;
        if4 <= if3;
        source_ptr6 <= source_ptr5;
        source_ptr17 <= source_ptr4;
      end if;
      if std_logic'((enable_state_do_0(3) AND advance_to_state_do_0(3))) = '1' then 
        break3 <= break2;
        break13 <= break1;
        dest_ptr7 <= dest_ptr6;
        if5 <= if4;
        source_ptr7 <= source_ptr6;
      end if;
      if std_logic'((enable_state_do_0(4) AND advance_to_state_do_0(4))) = '1' then 
        break4 <= break3;
        break14 <= break13;
        dest_ptr8 <= dest_ptr7;
        if6 <= if5;
        source_ptr8 <= source_ptr7;
      end if;
      if std_logic'((enable_state_do_0(5) AND advance_to_state_do_0(5))) = '1' then 
        break5 <= break4;
        break15 <= break14;
        dest_ptr9 <= dest_ptr8;
        if7 <= if6;
        source_ptr9 <= source_ptr8;
      end if;
      if std_logic'((enable_state_do_0(6) AND advance_to_state_do_0(6))) = '1' then 
        break6 <= break5;
        break16 <= break15;
        dest_ptr10 <= dest_ptr9;
        if8 <= if7;
        source_ptr10 <= source_ptr9;
      end if;
      if std_logic'((enable_state_do_0(7) AND advance_to_state_do_0(7))) = '1' then 
        break7 <= break6;
        break17 <= break16;
        dest_ptr11 <= dest_ptr10;
        if9 <= if8;
        source_ptr11 <= source_ptr10;
      end if;
      if std_logic'((enable_state_do_0(8) AND advance_to_state_do_0(8))) = '1' then 
        break8 <= break7;
        break18 <= break17;
        dest_ptr12 <= dest_ptr11;
        if10 <= if9;
        source_ptr12 <= source_ptr11;
      end if;
      if std_logic'((enable_state_do_0(9) AND advance_to_state_do_0(9))) = '1' then 
        break9 <= break8;
        break19 <= break18;
        dest_ptr13 <= dest_ptr12;
        if11 <= if10;
        source_ptr13 <= source_ptr12;
      end if;
      if std_logic'((enable_state_do_0(10) AND advance_to_state_do_0(10))) = '1' then 
        break10 <= break9;
        break20 <= break19;
        dest_ptr14 <= dest_ptr13;
        if12 <= if11;
        source_ptr14 <= source_ptr13;
      end if;
      if std_logic'((enable_state_do_0(11) AND advance_to_state_do_0(11))) = '1' then 
        break11 <= break10;
        break21 <= break20;
        dest_ptr15 <= dest_ptr14;
        if13 <= if12;
        source_ptr15 <= source_ptr14;
      end if;
      if std_logic'((enable_state_do_0(12) AND advance_to_state_do_0(12))) = '1' then 
        dereferenced_source_ptr2 <= accelerator_DMA_tutor_do_dma_master_resource0_fifo_out_aligned0;
        break12 <= break11;
        break22 <= break21;
        dest_ptr16 <= dest_ptr15;
        if14 <= if13;
        source_ptr16 <= source_ptr15;
      end if;
      if std_logic'((enable_state_do_0(13) AND advance_to_state_do_0(13))) = '1' then 
        break23 <= break22;
      end if;
      if std_logic'((enable_state_do_0(14) AND advance_to_state_do_0(14))) = '1' then 
        break24 <= break23;
        first_time_at_clock_13_state_do_1 <= std_logic_vector'("00000000000000000000000000000000");
      end if;
    end if;

  end process;

  dest_ptr21 <= A_WE_StdLogicVector(((if1) /= std_logic_vector'("00000000000000000000000000000000")), dest_ptr20, dest_ptr0);
  dest_ptr20 <= dest_ptr18;
  i9 <= A_WE_StdLogicVector(((if1) /= std_logic_vector'("00000000000000000000000000000000")), i8, i1);
  i8 <= i6;
  source_ptr21 <= A_WE_StdLogicVector(((if1) /= std_logic_vector'("00000000000000000000000000000000")), source_ptr20, source_ptr0);
  source_ptr20 <= source_ptr18;
  --c_subroutine_block process, accelerator_DMA_tutor_do_dma_do_dma0
  process (clk)
  begin
    if clk'event and clk = '1' then
      if std_logic'((enable_do_dma_state0(1) AND advance_to_do_dma_state0(1))) = '1' then 
        if1 <= subexp5;
        -- e_assignment on clock 0 for ../dma_c2h_tutorial.c:
        --return( 0 );
        return1 <= std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR((or_reduce(if0) OR or_reduce(return0))));
      end if;
      if std_logic'((enable_do_dma_state0(2) AND advance_to_do_dma_state0(2))) = '1' then 
        if2 <= subexp6;
      end if;
      if std_logic'((enable_do_dma_state0(4) AND advance_to_do_dma_state0(4))) = '1' then 
        dest_ptr18 <= dest_ptr17;
        i6 <= i5;
        source_ptr18 <= source_ptr17;
      end if;
    end if;

  end process;

  --vhdl renameroo for output signals
  accelerator_DMA_tutor_do_dma_master_resource0_address0 <= internal_accelerator_DMA_tutor_do_dma_master_resource0_address1;
  --vhdl renameroo for output signals
  accelerator_DMA_tutor_do_dma_master_resource0_flush0 <= internal_accelerator_DMA_tutor_do_dma_master_resource0_flush1;
  --vhdl renameroo for output signals
  accelerator_DMA_tutor_do_dma_master_resource0_read0 <= internal_accelerator_DMA_tutor_do_dma_master_resource0_read1;
  --vhdl renameroo for output signals
  accelerator_DMA_tutor_do_dma_master_resource1_address0 <= internal_accelerator_DMA_tutor_do_dma_master_resource1_address1;
  --vhdl renameroo for output signals
  accelerator_DMA_tutor_do_dma_master_resource1_byteenable0 <= internal_accelerator_DMA_tutor_do_dma_master_resource1_byteenable1;
  --vhdl renameroo for output signals
  accelerator_DMA_tutor_do_dma_master_resource1_write0 <= internal_accelerator_DMA_tutor_do_dma_master_resource1_write1;
  --vhdl renameroo for output signals
  accelerator_DMA_tutor_do_dma_master_resource1_writedata0 <= internal_accelerator_DMA_tutor_do_dma_master_resource1_writedata1;

end europa;



-- turn off superfluous VHDL processor warnings 
-- altera message_level Level1 
-- altera message_off 10034 10035 10036 10037 10230 10240 10030 

library altera;
use altera.altera_europa_support_lib.all;

library altera_mf;
use altera_mf.all;

library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;

library lpm;
use lpm.all;

entity accelerator_DMA_tutor_do_dma_cpu_registers0 is 
        port (
              -- inputs:
                 signal cpu_address0 : IN STD_LOGIC_VECTOR (2 DOWNTO 0);
                 signal cpu_clk : IN STD_LOGIC;
                 signal cpu_reset_n : IN STD_LOGIC;
                 signal cpu_select0 : IN STD_LOGIC;
                 signal cpu_write0 : IN STD_LOGIC;
                 signal cpu_writedata0 : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                 signal do_dma0 : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                 signal reset_n : IN STD_LOGIC;
                 signal slave_readdata0 : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                 signal slave_waitrequest_n0 : IN STD_LOGIC;

              -- outputs:
                 signal cpu_readdata1 : OUT STD_LOGIC_VECTOR (31 DOWNTO 0);
                 signal cpu_waitrequest_n0 : OUT STD_LOGIC;
                 signal slave_address0 : OUT STD_LOGIC_VECTOR (31 DOWNTO 0);
                 signal slave_functiondata0 : OUT STD_LOGIC_VECTOR (95 DOWNTO 0);
                 signal slave_read0 : OUT STD_LOGIC
              );
end entity accelerator_DMA_tutor_do_dma_cpu_registers0;


architecture europa of accelerator_DMA_tutor_do_dma_cpu_registers0 is
--synthesis read_comments_as_HDL on
--  component c2h_port_byte_refine is
--GENERIC (
--      c2h_param1 : NATURAL;
--        c2h_param2 : NATURAL;
--        c2h_param3 : NATURAL;
--        c2h_param4 : NATURAL
--      );
--    PORT (
--    signal port_d : OUT STD_LOGIC_VECTOR (2 DOWNTO 0);
--        signal port_c : IN STD_LOGIC;
--        signal port_a : IN STD_LOGIC_VECTOR (2 DOWNTO 0);
--        signal port_b : IN STD_LOGIC_VECTOR (2 DOWNTO 0)
--      );
--  end component c2h_port_byte_refine;
--synthesis read_comments_as_HDL off
                signal cpu_address_c2hplus0 :  STD_LOGIC_VECTOR (2 DOWNTO 0);
                signal dest_ptr22 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal internal_slave_read1 :  STD_LOGIC;
                signal length1 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal polled_data_ready0 :  STD_LOGIC;
                signal source_ptr22 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal tmp_cpu_readdata1 :  STD_LOGIC_VECTOR (31 DOWNTO 0);

--synthesis read_comments_as_HDL on
--                signal port_monitor0 :  STD_LOGIC_VECTOR (2 DOWNTO 0);

--synthesis read_comments_as_HDL off

begin

  --cpu interface register for dest_ptr22, which is an e_register
  process (cpu_clk, cpu_reset_n)
  begin
    if cpu_reset_n = '0' then
      dest_ptr22(31 DOWNTO 0) <= std_logic_vector'("00000000000000000000000000000000");
    elsif cpu_clk'event and cpu_clk = '1' then
      if std_logic'(((cpu_select0 AND cpu_write0) AND to_std_logic((((std_logic_vector'("00000000000000000000000000000") & (cpu_address_c2hplus0)) = std_logic_vector'("00000000000000000000000000000001")))))) = '1' then 
        dest_ptr22(31 DOWNTO 0) <= cpu_writedata0;
      end if;
    end if;

  end process;

  --cpu interface register for source_ptr22, which is an e_register
  process (cpu_clk, cpu_reset_n)
  begin
    if cpu_reset_n = '0' then
      source_ptr22(31 DOWNTO 0) <= std_logic_vector'("00000000000000000000000000000000");
    elsif cpu_clk'event and cpu_clk = '1' then
      if std_logic'(((cpu_select0 AND cpu_write0) AND to_std_logic((((std_logic_vector'("00000000000000000000000000000") & (cpu_address_c2hplus0)) = std_logic_vector'("00000000000000000000000000000010")))))) = '1' then 
        source_ptr22(31 DOWNTO 0) <= cpu_writedata0;
      end if;
    end if;

  end process;

  --cpu interface register for length1, which is an e_register
  process (cpu_clk, cpu_reset_n)
  begin
    if cpu_reset_n = '0' then
      length1(31 DOWNTO 0) <= std_logic_vector'("00000000000000000000000000000000");
    elsif cpu_clk'event and cpu_clk = '1' then
      if std_logic'(((cpu_select0 AND cpu_write0) AND to_std_logic((((std_logic_vector'("00000000000000000000000000000") & (cpu_address_c2hplus0)) = std_logic_vector'("00000000000000000000000000000011")))))) = '1' then 
        length1(31 DOWNTO 0) <= cpu_writedata0;
      end if;
    end if;

  end process;

  process (cpu_clk, cpu_reset_n)
  begin
    if cpu_reset_n = '0' then
      tmp_cpu_readdata1 <= std_logic_vector'("00000000000000000000000000000000");
    elsif cpu_clk'event and cpu_clk = '1' then
      if std_logic'((slave_waitrequest_n0 AND internal_slave_read1)) = '1' then 
        tmp_cpu_readdata1 <= slave_readdata0;
      end if;
    end if;

  end process;

  process (cpu_clk, cpu_reset_n)
  begin
    if cpu_reset_n = '0' then
      polled_data_ready0 <= std_logic'('0');
    elsif cpu_clk'event and cpu_clk = '1' then
      if std_logic'(((cpu_select0 AND cpu_write0) AND to_std_logic((((std_logic_vector'("00000000000000000000000000000") & (cpu_address_c2hplus0)) = std_logic_vector'("00000000000000000000000000000000")))))) = '1' then 
        polled_data_ready0 <= std_logic'('0');
      elsif std_logic'(slave_waitrequest_n0) = '1' then 
        polled_data_ready0 <= Vector_To_Std_Logic(-SIGNED(std_logic_vector'("00000000000000000000000000000001")));
      end if;
    end if;

  end process;

  process (cpu_clk, cpu_reset_n)
  begin
    if cpu_reset_n = '0' then
      internal_slave_read1 <= std_logic'('0');
    elsif cpu_clk'event and cpu_clk = '1' then
      if std_logic'((((cpu_write0 AND cpu_select0) AND to_std_logic((((std_logic_vector'("00000000000000000000000000000") & (cpu_address_c2hplus0)) = std_logic_vector'("00000000000000000000000000000000"))))) AND cpu_writedata0(0))) = '1' then 
        internal_slave_read1 <= Vector_To_Std_Logic(-SIGNED(std_logic_vector'("00000000000000000000000000000001")));
      elsif std_logic'(slave_waitrequest_n0) = '1' then 
        internal_slave_read1 <= std_logic'('0');
      end if;
    end if;

  end process;

  cpu_readdata1 <= A_WE_StdLogicVector((((std_logic_vector'("00000000000000000000000000000") & (cpu_address_c2hplus0)) = std_logic_vector'("00000000000000000000000000000000"))), (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(polled_data_ready0))), tmp_cpu_readdata1);
  cpu_waitrequest_n0 <= std_logic'('1');
  slave_address0 <= do_dma0;
  slave_functiondata0 <= dest_ptr22 & source_ptr22 & length1;
  --vhdl renameroo for output signals
  slave_read0 <= internal_slave_read1;
--synthesis translate_off
    cpu_address_c2hplus0 <= cpu_address0;
--synthesis translate_on
--synthesis read_comments_as_HDL on
--    port_monitor0 <= std_logic_vector'("000");
--    the_c2h_port_byte_refine : c2h_port_byte_refine
--      generic map(
--        c2h_param1 => 3,
--        c2h_param2 => 1,
--        c2h_param3 => 1,
--        c2h_param4 => 0
--      )
--      port map(
--                port_a => cpu_address0,
--                port_b => port_monitor0,
--                port_c => reset_n,
--                port_d => cpu_address_c2hplus0
--      );
--
--synthesis read_comments_as_HDL off

end europa;



-- turn off superfluous VHDL processor warnings 
-- altera message_level Level1 
-- altera message_off 10034 10035 10036 10037 10230 10240 10030 

library altera;
use altera.altera_europa_support_lib.all;

library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;

entity accelerator_DMA_tutor_do_dma is 
        port (
              -- inputs:
                 signal accelerator_DMA_tutor_do_dma_master_resource0_readdata0 : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                 signal accelerator_DMA_tutor_do_dma_master_resource0_readdatavalid0 : IN STD_LOGIC;
                 signal accelerator_DMA_tutor_do_dma_master_resource0_waitrequest_n0 : IN STD_LOGIC;
                 signal accelerator_DMA_tutor_do_dma_master_resource1_waitrequest_n0 : IN STD_LOGIC;
                 signal clk : IN STD_LOGIC;
                 signal cpu_address0 : IN STD_LOGIC_VECTOR (2 DOWNTO 0);
                 signal cpu_clk : IN STD_LOGIC;
                 signal cpu_reset_n : IN STD_LOGIC;
                 signal cpu_select0 : IN STD_LOGIC;
                 signal cpu_write0 : IN STD_LOGIC;
                 signal cpu_writedata0 : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                 signal do_dma_begin0 : IN STD_LOGIC;
                 signal do_dma_read0 : IN STD_LOGIC;
                 signal do_dma_select0 : IN STD_LOGIC;
                 signal dummy_master_waitrequest : IN STD_LOGIC;
                 signal dummy_slave_address : IN STD_LOGIC;
                 signal dummy_slave_chipselect : IN STD_LOGIC;
                 signal reset_n : IN STD_LOGIC;
                 signal slave_readdata0 : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                 signal slave_waitrequest_n0 : IN STD_LOGIC;

              -- outputs:
                 signal accelerator_DMA_tutor_do_dma_master_resource0_address0 : OUT STD_LOGIC_VECTOR (31 DOWNTO 0);
                 signal accelerator_DMA_tutor_do_dma_master_resource0_flush0 : OUT STD_LOGIC;
                 signal accelerator_DMA_tutor_do_dma_master_resource0_read0 : OUT STD_LOGIC;
                 signal accelerator_DMA_tutor_do_dma_master_resource1_address0 : OUT STD_LOGIC_VECTOR (31 DOWNTO 0);
                 signal accelerator_DMA_tutor_do_dma_master_resource1_byteenable0 : OUT STD_LOGIC_VECTOR (3 DOWNTO 0);
                 signal accelerator_DMA_tutor_do_dma_master_resource1_write0 : OUT STD_LOGIC;
                 signal accelerator_DMA_tutor_do_dma_master_resource1_writedata0 : OUT STD_LOGIC_VECTOR (31 DOWNTO 0);
                 signal cpu_readdata0 : OUT STD_LOGIC_VECTOR (31 DOWNTO 0);
                 signal cpu_readdata1 : OUT STD_LOGIC_VECTOR (31 DOWNTO 0);
                 signal cpu_waitrequest_n0 : OUT STD_LOGIC;
                 signal do_dma_waitrequest_n0 : OUT STD_LOGIC;
                 signal dummy_master_address : OUT STD_LOGIC_VECTOR (31 DOWNTO 0);
                 signal dummy_master_write : OUT STD_LOGIC;
                 signal dummy_master_writedata : OUT STD_LOGIC_VECTOR (31 DOWNTO 0);
                 signal dummy_slave_readdata : OUT STD_LOGIC_VECTOR (31 DOWNTO 0);
                 signal slave_address0 : OUT STD_LOGIC_VECTOR (31 DOWNTO 0);
                 signal slave_read0 : OUT STD_LOGIC
              );
end entity accelerator_DMA_tutor_do_dma;


architecture europa of accelerator_DMA_tutor_do_dma is
component accelerator_DMA_tutor_do_dma_do_dma0 is 
           port (
                 -- inputs:
                    signal accelerator_DMA_tutor_do_dma_master_resource0_readdata0 : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                    signal accelerator_DMA_tutor_do_dma_master_resource0_readdatavalid0 : IN STD_LOGIC;
                    signal accelerator_DMA_tutor_do_dma_master_resource0_waitrequest_n0 : IN STD_LOGIC;
                    signal accelerator_DMA_tutor_do_dma_master_resource1_waitrequest_n0 : IN STD_LOGIC;
                    signal clk : IN STD_LOGIC;
                    signal do_dma_begin0 : IN STD_LOGIC;
                    signal do_dma_functiondata0 : IN STD_LOGIC_VECTOR (95 DOWNTO 0);
                    signal do_dma_read0 : IN STD_LOGIC;
                    signal do_dma_select0 : IN STD_LOGIC;
                    signal reset_n : IN STD_LOGIC;

                 -- outputs:
                    signal accelerator_DMA_tutor_do_dma_master_resource0_address0 : OUT STD_LOGIC_VECTOR (31 DOWNTO 0);
                    signal accelerator_DMA_tutor_do_dma_master_resource0_flush0 : OUT STD_LOGIC;
                    signal accelerator_DMA_tutor_do_dma_master_resource0_read0 : OUT STD_LOGIC;
                    signal accelerator_DMA_tutor_do_dma_master_resource1_address0 : OUT STD_LOGIC_VECTOR (31 DOWNTO 0);
                    signal accelerator_DMA_tutor_do_dma_master_resource1_byteenable0 : OUT STD_LOGIC_VECTOR (3 DOWNTO 0);
                    signal accelerator_DMA_tutor_do_dma_master_resource1_write0 : OUT STD_LOGIC;
                    signal accelerator_DMA_tutor_do_dma_master_resource1_writedata0 : OUT STD_LOGIC_VECTOR (31 DOWNTO 0);
                    signal cpu_readdata0 : OUT STD_LOGIC_VECTOR (31 DOWNTO 0);
                    signal do_dma_waitrequest_n0 : OUT STD_LOGIC
                 );
end component accelerator_DMA_tutor_do_dma_do_dma0;

component accelerator_DMA_tutor_do_dma_cpu_registers0 is 
           port (
                 -- inputs:
                    signal cpu_address0 : IN STD_LOGIC_VECTOR (2 DOWNTO 0);
                    signal cpu_clk : IN STD_LOGIC;
                    signal cpu_reset_n : IN STD_LOGIC;
                    signal cpu_select0 : IN STD_LOGIC;
                    signal cpu_write0 : IN STD_LOGIC;
                    signal cpu_writedata0 : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                    signal do_dma0 : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                    signal reset_n : IN STD_LOGIC;
                    signal slave_readdata0 : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                    signal slave_waitrequest_n0 : IN STD_LOGIC;

                 -- outputs:
                    signal cpu_readdata1 : OUT STD_LOGIC_VECTOR (31 DOWNTO 0);
                    signal cpu_waitrequest_n0 : OUT STD_LOGIC;
                    signal slave_address0 : OUT STD_LOGIC_VECTOR (31 DOWNTO 0);
                    signal slave_functiondata0 : OUT STD_LOGIC_VECTOR (95 DOWNTO 0);
                    signal slave_read0 : OUT STD_LOGIC
                 );
end component accelerator_DMA_tutor_do_dma_cpu_registers0;

                signal do_dma0 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal do_dma_functiondata0 :  STD_LOGIC_VECTOR (95 DOWNTO 0);
                signal dummy_address_sink :  STD_LOGIC;
                signal dummy_chipselect_sink :  STD_LOGIC;
                signal dummy_waitrequest_sink :  STD_LOGIC;
                signal internal_accelerator_DMA_tutor_do_dma_master_resource0_address0 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal internal_accelerator_DMA_tutor_do_dma_master_resource0_flush0 :  STD_LOGIC;
                signal internal_accelerator_DMA_tutor_do_dma_master_resource0_read0 :  STD_LOGIC;
                signal internal_accelerator_DMA_tutor_do_dma_master_resource1_address0 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal internal_accelerator_DMA_tutor_do_dma_master_resource1_byteenable0 :  STD_LOGIC_VECTOR (3 DOWNTO 0);
                signal internal_accelerator_DMA_tutor_do_dma_master_resource1_write0 :  STD_LOGIC;
                signal internal_accelerator_DMA_tutor_do_dma_master_resource1_writedata0 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal internal_cpu_readdata0 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal internal_cpu_readdata1 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal internal_cpu_waitrequest_n0 :  STD_LOGIC;
                signal internal_do_dma_waitrequest_n0 :  STD_LOGIC;
                signal internal_slave_address0 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal internal_slave_read0 :  STD_LOGIC;
                signal slave_functiondata0 :  STD_LOGIC_VECTOR (95 DOWNTO 0);

begin

  --the_accelerator_DMA_tutor_do_dma_do_dma0, which is an e_instance
  the_accelerator_DMA_tutor_do_dma_do_dma0 : accelerator_DMA_tutor_do_dma_do_dma0
    port map(
      accelerator_DMA_tutor_do_dma_master_resource0_address0 => internal_accelerator_DMA_tutor_do_dma_master_resource0_address0,
      accelerator_DMA_tutor_do_dma_master_resource0_flush0 => internal_accelerator_DMA_tutor_do_dma_master_resource0_flush0,
      accelerator_DMA_tutor_do_dma_master_resource0_read0 => internal_accelerator_DMA_tutor_do_dma_master_resource0_read0,
      accelerator_DMA_tutor_do_dma_master_resource1_address0 => internal_accelerator_DMA_tutor_do_dma_master_resource1_address0,
      accelerator_DMA_tutor_do_dma_master_resource1_byteenable0 => internal_accelerator_DMA_tutor_do_dma_master_resource1_byteenable0,
      accelerator_DMA_tutor_do_dma_master_resource1_write0 => internal_accelerator_DMA_tutor_do_dma_master_resource1_write0,
      accelerator_DMA_tutor_do_dma_master_resource1_writedata0 => internal_accelerator_DMA_tutor_do_dma_master_resource1_writedata0,
      cpu_readdata0 => internal_cpu_readdata0,
      do_dma_waitrequest_n0 => internal_do_dma_waitrequest_n0,
      accelerator_DMA_tutor_do_dma_master_resource0_readdata0 => accelerator_DMA_tutor_do_dma_master_resource0_readdata0,
      accelerator_DMA_tutor_do_dma_master_resource0_readdatavalid0 => accelerator_DMA_tutor_do_dma_master_resource0_readdatavalid0,
      accelerator_DMA_tutor_do_dma_master_resource0_waitrequest_n0 => accelerator_DMA_tutor_do_dma_master_resource0_waitrequest_n0,
      accelerator_DMA_tutor_do_dma_master_resource1_waitrequest_n0 => accelerator_DMA_tutor_do_dma_master_resource1_waitrequest_n0,
      clk => clk,
      do_dma_begin0 => do_dma_begin0,
      do_dma_functiondata0 => do_dma_functiondata0,
      do_dma_read0 => do_dma_read0,
      do_dma_select0 => do_dma_select0,
      reset_n => reset_n
    );


  --sub_do_dma0, which is an e_avalon_slave
  --accelerator_DMA_tutor_do_dma_master_resource0, which is an e_avalon_master
  --accelerator_DMA_tutor_do_dma_master_resource1, which is an e_avalon_master
  --the_cpu_registers0, which is an e_instance
  the_cpu_registers0 : accelerator_DMA_tutor_do_dma_cpu_registers0
    port map(
      cpu_readdata1 => internal_cpu_readdata1,
      cpu_waitrequest_n0 => internal_cpu_waitrequest_n0,
      slave_address0 => internal_slave_address0,
      slave_functiondata0 => slave_functiondata0,
      slave_read0 => internal_slave_read0,
      cpu_address0 => cpu_address0,
      cpu_clk => cpu_clk,
      cpu_reset_n => cpu_reset_n,
      cpu_select0 => cpu_select0,
      cpu_write0 => cpu_write0,
      cpu_writedata0 => cpu_writedata0,
      do_dma0 => do_dma0,
      reset_n => reset_n,
      slave_readdata0 => slave_readdata0,
      slave_waitrequest_n0 => slave_waitrequest_n0
    );


  do_dma_functiondata0 <= slave_functiondata0;
  --cpu_interface0, which is an e_avalon_slave
  --internal_master0, which is an e_avalon_master
  dummy_master_write <= std_logic'('0');
  dummy_master_writedata <= std_logic_vector'("00000000000000000000000000000000");
  dummy_waitrequest_sink <= dummy_master_waitrequest;
  dummy_master_address <= std_logic_vector'("00000000000000000000000000000000");
  dummy_chipselect_sink <= dummy_slave_chipselect;
  dummy_address_sink <= dummy_slave_address;
  dummy_slave_readdata <= std_logic_vector'("00000000000000000000000000000000");
  --dummy_master, which is an e_avalon_master
  --dummy_slave, which is an e_avalon_slave
  do_dma0 <= std_logic_vector'("00000000000000000000000010100000");
  --vhdl renameroo for output signals
  accelerator_DMA_tutor_do_dma_master_resource0_address0 <= internal_accelerator_DMA_tutor_do_dma_master_resource0_address0;
  --vhdl renameroo for output signals
  accelerator_DMA_tutor_do_dma_master_resource0_flush0 <= internal_accelerator_DMA_tutor_do_dma_master_resource0_flush0;
  --vhdl renameroo for output signals
  accelerator_DMA_tutor_do_dma_master_resource0_read0 <= internal_accelerator_DMA_tutor_do_dma_master_resource0_read0;
  --vhdl renameroo for output signals
  accelerator_DMA_tutor_do_dma_master_resource1_address0 <= internal_accelerator_DMA_tutor_do_dma_master_resource1_address0;
  --vhdl renameroo for output signals
  accelerator_DMA_tutor_do_dma_master_resource1_byteenable0 <= internal_accelerator_DMA_tutor_do_dma_master_resource1_byteenable0;
  --vhdl renameroo for output signals
  accelerator_DMA_tutor_do_dma_master_resource1_write0 <= internal_accelerator_DMA_tutor_do_dma_master_resource1_write0;
  --vhdl renameroo for output signals
  accelerator_DMA_tutor_do_dma_master_resource1_writedata0 <= internal_accelerator_DMA_tutor_do_dma_master_resource1_writedata0;
  --vhdl renameroo for output signals
  cpu_readdata0 <= internal_cpu_readdata0;
  --vhdl renameroo for output signals
  cpu_readdata1 <= internal_cpu_readdata1;
  --vhdl renameroo for output signals
  cpu_waitrequest_n0 <= internal_cpu_waitrequest_n0;
  --vhdl renameroo for output signals
  do_dma_waitrequest_n0 <= internal_do_dma_waitrequest_n0;
  --vhdl renameroo for output signals
  slave_address0 <= internal_slave_address0;
  --vhdl renameroo for output signals
  slave_read0 <= internal_slave_read0;

end europa;



